GNU bug report logs - #36492
c-mode fails with errors during fontification

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs,cc-mode; Reported by: Juri Linkov <juri@HIDDEN>; dated Wed, 3 Jul 2019 20:58:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug Marked as fixed in versions 27.0.50. Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
bug Marked as found in versions 27.0.50 and reopened. Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 8 Jul 2019 21:59:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 17:59:01 2019
Received: from localhost ([127.0.0.1]:59804 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkbf2-0003Hq-Rc
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 17:59:01 -0400
Received: from mail-io1-f54.google.com ([209.85.166.54]:42687)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1hkbf0-0003HZ-KQ
 for 36492 <at> debbugs.gnu.org; Mon, 08 Jul 2019 17:58:59 -0400
Received: by mail-io1-f54.google.com with SMTP id u19so38734405ior.9
 for <36492 <at> debbugs.gnu.org>; Mon, 08 Jul 2019 14:58:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=JlIQfy16p5gj8sViXBNNW1yWV6/69q8yo9JTS+XlF3U=;
 b=F8Zt33h//62Rf/s2hJTr1j73WkWVzI+8ZfT90oZizOGLA87duFMDBCUNzeq2K6lTFS
 ZCfguuNgzCixf0m1Qmy3wrbPaPGdYyY57VPe0COyvBRwV94c0xHnQ7CQOAePH2nWAIL3
 chta23ftcP+SQHCUiGBRIH3Qh8k/QEfcBiFlV2jYnlEbVnglAqxhdmNr3hl1+yBpbySH
 H3ibGD4yXTHrs1dGA2G4yVbSxZg/gYxAwHJiYxZTrYYDKBj75BL5XSQIh/M3Fyb65tEQ
 j4th1/QIVwv2XuMlGvd8Fv7a0waH++pqzdxJRGE49T6EsOliNFG0+CmlntkTBueLKKfq
 nmzA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=JlIQfy16p5gj8sViXBNNW1yWV6/69q8yo9JTS+XlF3U=;
 b=VtNM/1v49Cj7TxKcHKD+ctqZXefI2trJQvFecnI9nsBCrhOFQGoytCiReDKt42q8Gv
 kuvTDleqjUdQqUFodBGqNtzfzCyBJSx1oarEyS8ITEAeoKkdVa3NF2UHgr1IgZsn6J3p
 ocDHE82izJzMe2KRD5KzJvDYzEJiHVpEk4CLM3SE1rPV6tTtgmn3YcMMeu6mY8DhTIck
 YOAbENQIwGFPbpj7HnjGOuMbdm6nOucnjoGejWhFeyj3fR0Drxhcl+oiufEU9SWL5ppc
 1NWs6wZmVEX106ftsH5ze1jOJOeAZ12JeahaBYNGKaQTs4yOKi465XHBUEa3O8LsiFNj
 0OIw==
X-Gm-Message-State: APjAAAVt2Hg9fIvHCVrjz/xt+tjARhVXmcqQoyw6GOJZM7SDZc5F1oSu
 zYgGvJmArMk0wG38KonUbBrS5HHC
X-Google-Smtp-Source: APXvYqw9e7vDJD7kNLVW1mZZLwz4VRK8gyMkm2yh9lEvOxD/OwE21HaEbrPTpAOlAbXataSX3USsdQ==
X-Received: by 2002:a5d:834f:: with SMTP id q15mr987085ior.59.1562623132426;
 Mon, 08 Jul 2019 14:58:52 -0700 (PDT)
Received: from minid (cbl-45-2-119-34.yyz.frontiernetworks.ca. [45.2.119.34])
 by smtp.gmail.com with ESMTPSA id
 x22sm14009689ioh.87.2019.07.08.14.58.51
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Mon, 08 Jul 2019 14:58:51 -0700 (PDT)
From: Noam Postavsky <npostavs@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
References: <20190706142748.85417.qmail@HIDDEN>
 <871rz15xp1.fsf@HIDDEN> <20190708125332.GA5244@ACM>
 <CAM-tV-9YFvjbbhws4oZWegpui3hKC1k=cWTDTyB9EKFP1hbjmQ@HIDDEN>
 <877e8s19p9.fsf@HIDDEN>
Date: Mon, 08 Jul 2019 17:58:50 -0400
In-Reply-To: <877e8s19p9.fsf@HIDDEN> (Juri Linkov's message of "Tue, 
 09 Jul 2019 00:46:10 +0300")
Message-ID: <87r2702nol.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.2.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Juri Linkov writes: >> Rather than ignore-errors, perhaps
 using with-demoted-errors would >> still let the errors be noticed without
 too much inconvenience? > > I tried this change: > > (unless (eq major-mode
 'fundamenta [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: linkov.net]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (npostavs[at]gmail.com)
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.166.54 listed in list.dnswl.org]
 1.3 PDS_NO_HELO_DNS        High profile HELO but no A record
X-Debbugs-Envelope-To: 36492
Cc: Alan Mackenzie <acm@HIDDEN>, 36492 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

Juri Linkov <juri@HIDDEN> writes:

>> Rather than ignore-errors, perhaps using with-demoted-errors would
>> still let the errors be noticed without too much inconvenience?
>
> I tried this change:
>
>  	  (unless (eq major-mode 'fundamental-mode)
> -	    (font-lock-ensure))))
> +	    (with-demoted-errors (font-lock-ensure)))))
>        (setq text (buffer-string))
>        (when (eq mode 'diff-mode)
>  	(setq ovs (mapcar (lambda (ov) (list ov (overlay-start ov)
>
> But it pops up the same error backtrace buffer.

Right, if you have debug-on-error set, with-demoted-errors won't stop
the debugger.  But you should be able to continue with 'c' as normal, or
if you don't have debug-on-error set, you only get a message.





Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 8 Jul 2019 21:48:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 17:48:44 2019
Received: from localhost ([127.0.0.1]:59785 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkbV6-00032s-Ky
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 17:48:44 -0400
Received: from azure.elm.relay.mailchannels.net ([23.83.212.7]:48250)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1hkbV4-00032g-9p
 for 36492 <at> debbugs.gnu.org; Mon, 08 Jul 2019 17:48:42 -0400
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 434171426EF;
 Mon,  8 Jul 2019 21:48:41 +0000 (UTC)
Received: from pdx1-sub0-mail-a97.g.dreamhost.com
 (100-96-92-193.trex.outbound.svc.cluster.local [100.96.92.193])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id B5CE7142BE8;
 Mon,  8 Jul 2019 21:48:40 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a97.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.3); Mon, 08 Jul 2019 21:48:41 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Plucky-Little: 7156d243731c30a7_1562622521016_589675142
X-MC-Loop-Signature: 1562622521016:2499581453
X-MC-Ingress-Time: 1562622521016
Received: from pdx1-sub0-mail-a97.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a97.g.dreamhost.com (Postfix) with ESMTP id 82FD381FD1;
 Mon,  8 Jul 2019 14:48:35 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=IiTpBZVgl7xFRov2pG+Lry1nKp8=; b=
 ifPOh0E4t9qJr4TCHsKeHpJ5mKwP5RT5NxHSA0LCdGicHaxWg9lFlogR6nJ47L1P
 LHgWXfkUx5QIlld4G2tJw6w6bl9oo6MHINg8PdcgHDCxQ/N+8aqQN1uif4U2zHBd
 bip6sYZ2v3PxeY/S89h46uB30I6ykdpz9ODDRPLGqDM=
Received: from mail.jurta.org (m91-129-109-127.cust.tele2.ee [91.129.109.127])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a97.g.dreamhost.com (Postfix) with ESMTPSA id 39DCD81FC1;
 Mon,  8 Jul 2019 14:48:31 -0700 (PDT)
X-DH-BACKEND: pdx1-sub0-mail-a97
From: Juri Linkov <juri@HIDDEN>
To: Noam Postavsky <npostavs@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
Organization: LINKOV.NET
References: <20190706142748.85417.qmail@HIDDEN>
 <871rz15xp1.fsf@HIDDEN> <20190708125332.GA5244@ACM>
 <CAM-tV-9YFvjbbhws4oZWegpui3hKC1k=cWTDTyB9EKFP1hbjmQ@HIDDEN>
Date: Tue, 09 Jul 2019 00:46:10 +0300
In-Reply-To: <CAM-tV-9YFvjbbhws4oZWegpui3hKC1k=cWTDTyB9EKFP1hbjmQ@HIDDEN>
 (Noam Postavsky's message of "Mon, 8 Jul 2019 09:16:56 -0400")
Message-ID: <877e8s19p9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgeduvddrgedugddtudcutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefhvffuohhfffgjkfgfgggtsehttdertddtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtledruddvjeenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdelrdduvdejpdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepnhhpohhsthgrvhhssehgmhgrihhlrdgtohhmnecuvehluhhsthgvrhfuihiivgeptd
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36492
Cc: Alan Mackenzie <acm@HIDDEN>, 36492 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > I wonder if ignore-errors around font-lock-ensure in mm-display-inline-fontify
>> > is still necessary to ensure no more bugs in other modes disrupt Gnus
>> > by erroneous code in attachments?  Or maybe raising such errors will help
>> > to find fontification bugs sooner?
>>
>> My feeling is that it's better to let the errors happen, so that we can
>> debug them.  But on the other hand, it's not me that gets inconvenienced
>> by such an error (I don't use gnus).
>
> Rather than ignore-errors, perhaps using with-demoted-errors would
> still let the errors be noticed without too much inconvenience?

I tried this change:

diff --git a/lisp/gnus/mm-view.el b/lisp/gnus/mm-view.el
index 6ffa1fc168..c833f2ed01 100644
--- a/lisp/gnus/mm-view.el
+++ b/lisp/gnus/mm-view.el
@@ -500,7 +500,7 @@ mm-display-inline-fontify
 	      (setq mode major-mode)))
 	  ;; Do not fontify if the guess mode is fundamental.
 	  (unless (eq major-mode 'fundamental-mode)
-	    (font-lock-ensure))))
+	    (with-demoted-errors (font-lock-ensure)))))
       (setq text (buffer-string))
       (when (eq mode 'diff-mode)
 	(setq ovs (mapcar (lambda (ov) (list ov (overlay-start ov)

But it pops up the same error backtrace buffer.




Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 8 Jul 2019 13:47:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 09:47:21 2019
Received: from localhost ([127.0.0.1]:58070 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkTzD-0006Md-1m
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 09:47:21 -0400
Received: from mail-wr1-f47.google.com ([209.85.221.47]:40869)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1hkTzB-0006MO-L4
 for 36492 <at> debbugs.gnu.org; Mon, 08 Jul 2019 09:47:18 -0400
Received: by mail-wr1-f47.google.com with SMTP id r1so10856252wrl.7
 for <36492 <at> debbugs.gnu.org>; Mon, 08 Jul 2019 06:47:17 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=+tUNHpKGJwwnBvf91wmF5AGxjz/YA+OHbpo1aJx4xUo=;
 b=NZRAn7imujVaHv1js+YQsCkoIRPUU+KolzuWndxV/rYNHpigu/C8wmxHwZQhcsNylO
 hFQW+3s+Xh0NaU0I1zLLWlrGypGLYWxTuKcdtsXynbMkfU5HiUMMwd8xk/wF9mUWgB0h
 4JEgo519rvsy33tRwqy0fcDFUAAS4KBXnJxcnSEV5r79HrJw04AhjUKT2bpnSNItzD78
 hn7i949eLYWqDu6Ovs8gwnFASVbljCEkONOuTuE1B1nUdyum8RmVeW/XRq3Sw9PivgtJ
 GgN8P45boMb56db5Ib85cJnWsRnZaKCSKmD8Xhopyo9BR385MYH3n9ZSmdCbkR7N4431
 0efg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=+tUNHpKGJwwnBvf91wmF5AGxjz/YA+OHbpo1aJx4xUo=;
 b=WvArY6hKqmauD4MNYMtTaIzBtz+fbeXkYlNKpqOb2LJZuW2tXmhLnKtAO8L1YahjEs
 cH0Z4rwjbTcoZULy4BR2lyb2r/9Mjbw7oGYrpHjTEyJCx0lE1+HVkFsJ2qrFnwwSW/4E
 WOL4nB0bKohzIQPnPKwJfuCanP4g+ZSgukUCqYDbEzgzyRzOsSI2Gvli217SIJqeRHs4
 O2YOolbXy9kkaIMlbybqdbniwA8ABD/tttfEMt4dgZwCDa6yPo0xKNsKB05APQdZR+EY
 +S7OE2Nkg7U34XIhHSnoNst0T+Kosjq8vpSblxslwGDtcmI8xgCivczgPAmrns68aLQ4
 UEfw==
X-Gm-Message-State: APjAAAV/PKUzJEs64oh4ywn0LJZbZhT8Ujb1BHRRWZi8oAq7k0TUIPPK
 A4UEQzAaAfyQ5KDmCjvlqI8=
X-Google-Smtp-Source: APXvYqyhMBfzEL+PX58xdTSQbg5ViKcePmN1KJLF8xpIowTgfpS5SOctUPDDXsBS4+T2vwwGCNPzyw==
X-Received: by 2002:adf:e691:: with SMTP id r17mr19342448wrm.67.1562593631552; 
 Mon, 08 Jul 2019 06:47:11 -0700 (PDT)
Received: from [192.168.0.195] ([109.110.245.170])
 by smtp.googlemail.com with ESMTPSA id r5sm6737641wmh.35.2019.07.08.06.47.10
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 08 Jul 2019 06:47:10 -0700 (PDT)
Subject: Re: bug#36492: c-mode fails with errors during fontification
To: 36492 <at> debbugs.gnu.org, acm@HIDDEN, juri@HIDDEN
References: <20190706142748.85417.qmail@HIDDEN>
 <871rz15xp1.fsf@HIDDEN> <20190708125332.GA5244@ACM>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <a099b5fd-42ed-4117-4f0e-7df2bf3ff2d7@HIDDEN>
Date: Mon, 8 Jul 2019 16:47:08 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.7.2
MIME-Version: 1.0
In-Reply-To: <20190708125332.GA5244@ACM>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 1.8 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 08.07.2019 15:53, Alan Mackenzie wrote: >> I wonder if
 ignore-errors around font-lock-ensure in mm-display-inline-fontify >> is still
 necessary to ensure no more bugs in other modes disrupt Gnus >> [...] 
 Content analysis details:   (1.8 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.47 listed in list.dnswl.org]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
 mail domains are different
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (dgutov[at]yandex.ru)
 1.3 PDS_NO_HELO_DNS        High profile HELO but no A record
 0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and
 EnvelopeFrom freemail headers are different
X-Debbugs-Envelope-To: 36492
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.8 (/)

On 08.07.2019 15:53, Alan Mackenzie wrote:
>> I wonder if ignore-errors around font-lock-ensure in mm-display-inline-fontify
>> is still necessary to ensure no more bugs in other modes disrupt Gnus
>> by erroneous code in attachments?  Or maybe raising such errors will help
>> to find fontification bugs sooner?
> My feeling is that it's better to let the errors happen, so that we can
> debug them.  But on the other hand, it's not me that gets inconvenienced
> by such an error (I don't use gnus).

I'd like to second that.

And with similar errors taken care of, it might become feasible to use 
e.g. c-mode with mmm-mode.




Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 8 Jul 2019 13:17:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 09:17:23 2019
Received: from localhost ([127.0.0.1]:58053 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkTWD-0005ev-5v
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 09:17:21 -0400
Received: from mail-ot1-f43.google.com ([209.85.210.43]:43359)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1hkTWA-0005eh-Fg
 for 36492 <at> debbugs.gnu.org; Mon, 08 Jul 2019 09:17:19 -0400
Received: by mail-ot1-f43.google.com with SMTP id q10so16104554otk.10
 for <36492 <at> debbugs.gnu.org>; Mon, 08 Jul 2019 06:17:18 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to;
 bh=WDQazvtI1dfZuSQtfYLDD9DaEN+pjzpm8SvYFq3wybY=;
 b=mJDWA+Tekt7Q2SecxQszWBpKZKjKtpja8PuhKZbD78xyY3g5EpMzj2YJpTs2Lc1pBH
 ZUurclaj+Egvzlx6QrEQdzQA1uiFCY0JkBf+XAXVmrBiCZBHeQYFsdPnJ7XI8sDrE1Qv
 pQQSWsPaQleH4ilcSsR83g5V5+WsCCVg/IFCBHEYXtvca83FGPLiz5DZCl5WMUW0j2sz
 EWERJ/DeJdgKOU1PgdQvWWqdaPnMzF+4V9WIGNLNAmdMXHceb8eWa/DQobCVjP1hBsek
 XjZhGeVCf1eeXrnofzwruBJxAzSMr5Mz/9bQ6g/MB0TTtjzAiQoqkedYg9VNdIAtbMIY
 ahrg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to;
 bh=WDQazvtI1dfZuSQtfYLDD9DaEN+pjzpm8SvYFq3wybY=;
 b=ZvEXT6DkJFFtpMpeVy3JY3LPv7bLHOzblpTwpOdc3vyEIgaBcjsvZ69AMFJkB7i4fQ
 CgfxpIFl6YP1A0XAU5QKjVM4vCaO6/94gEx7dRDyHP68+MKbUkw2sp/AomSlaWApv7De
 xpXGpoXTK3NIETff5RmUCDhF7fmbzDCtQE5ytChCcHPFgy76Oy4x+VxUsQEmkM63bfXk
 kq01RAcLk2Qh0RGrLgxrN6emzD+yjVQryBm+yBLtbHIH8wfw2Ylb1R3b70rEn4hsNlsY
 Xs3hbYk24KE/N+VQz3dWWdpsk0t8EUUZ7x9bO0/Fcg168qsewZz3iyA4Vzy075XYHvDp
 63lg==
X-Gm-Message-State: APjAAAUp01v9Hw/DMtD8tsBzQ/Ea8n608VwZUfNCiHcuJS7SIhFoYvr0
 JXE/rrglG003X8fC6VxZ34Uce/wllv4l/uPZHzSAiA==
X-Google-Smtp-Source: APXvYqzVARKfm0dzZtzJFFXNx02m71k4qp8QcV/+t0PEZGTDeMQGWjeX2GH8Z8AJ4A+5ECyYTdy+sSdpMLC50uT1Z8U=
X-Received: by 2002:a05:6830:15c4:: with SMTP id
 j4mr13380013otr.115.1562591832660; 
 Mon, 08 Jul 2019 06:17:12 -0700 (PDT)
MIME-Version: 1.0
References: <20190706142748.85417.qmail@HIDDEN>
 <871rz15xp1.fsf@HIDDEN> <20190708125332.GA5244@ACM>
In-Reply-To: <20190708125332.GA5244@ACM>
From: Noam Postavsky <npostavs@HIDDEN>
Date: Mon, 8 Jul 2019 09:16:56 -0400
Message-ID: <CAM-tV-9YFvjbbhws4oZWegpui3hKC1k=cWTDTyB9EKFP1hbjmQ@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
To: 36492 <at> debbugs.gnu.org, Alan Mackenzie <acm@HIDDEN>,
 Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On Mon, 8 Jul 2019 at 08:54,
 Alan Mackenzie wrote: > > I wonder
 if ignore-errors around font-lock-ensure in mm-display-inline-fontify > >
 is still necessary to ensure no more bugs in other modes disrupt Gnus > >
 by erroneous code in attachments? Or ma [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (npostavs[at]gmail.com)
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.210.43 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.210.43 listed in wl.mailspike.net]
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: muc.de]
 1.3 PDS_NO_HELO_DNS        High profile HELO but no A record
X-Debbugs-Envelope-To: 36492
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

On Mon, 8 Jul 2019 at 08:54, Alan Mackenzie <acm@HIDDEN> wrote:

> > I wonder if ignore-errors around font-lock-ensure in mm-display-inline-fontify
> > is still necessary to ensure no more bugs in other modes disrupt Gnus
> > by erroneous code in attachments?  Or maybe raising such errors will help
> > to find fontification bugs sooner?
>
> My feeling is that it's better to let the errors happen, so that we can
> debug them.  But on the other hand, it's not me that gets inconvenienced
> by such an error (I don't use gnus).

Rather than ignore-errors, perhaps using with-demoted-errors would
still let the errors be noticed without too much inconvenience?




Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492-done <at> debbugs.gnu.org:


Received: (at 36492-done) by debbugs.gnu.org; 8 Jul 2019 12:53:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 08:53:49 2019
Received: from localhost ([127.0.0.1]:58026 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkT9Q-00055M-Qf
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 08:53:49 -0400
Received: from colin.muc.de ([193.149.48.1]:51629 helo=mail.muc.de)
 by debbugs.gnu.org with smtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1hkT9O-00055C-9g
 for 36492-done <at> debbugs.gnu.org; Mon, 08 Jul 2019 08:53:47 -0400
Received: (qmail 22265 invoked by uid 3782); 8 Jul 2019 12:53:33 -0000
Received: from acm.muc.de (p4FE15FEC.dip0.t-ipconnect.de [79.225.95.236]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Mon, 08 Jul 2019 14:53:32 +0200
Received: (qmail 5251 invoked by uid 1000); 8 Jul 2019 12:53:32 -0000
Date: Mon, 8 Jul 2019 12:53:32 +0000
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
Message-ID: <20190708125332.GA5244@ACM>
References: <20190706142748.85417.qmail@HIDDEN>
 <871rz15xp1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <871rz15xp1.fsf@HIDDEN>
User-Agent: Mutt/1.10.1 (2018-07-13)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36492-done
Cc: 36492-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello, Juri.

On Mon, Jul 08, 2019 at 00:52:02 +0300, Juri Linkov wrote:
> >>> Opening this message in Gnus fails with the following backtrace
> >>> because c-mode fails to fontify the attachment.

> >> Actually, with the attachment in this message the bug in c-mode
> >> font-lock is much easier to reproduce.

> > That is one ugly piece of erroneous C.  ;-)

> > What triggers the bug is the ) without a preceding (.  A variable
> > recording the position of the opening ( is still set to nil, and we
> > tried to use it in the given buffer with the unbalanced ).

> >> [-- text/x-csrc, encoding 7bit, charset: US-ASCII, 3 lines, name: test.c --]

> > The following patch fixes it, I hope.  Would you please do the usual,
> > and confirm that it does indeed fix the bug (or tell me what's still
> > wrong).

> Thanks, Alan.  Now there is no error anymore.

Thanks.  I've committed the fix, and I'm closing the bug.

> I wonder if ignore-errors around font-lock-ensure in mm-display-inline-fontify
> is still necessary to ensure no more bugs in other modes disrupt Gnus
> by erroneous code in attachments?  Or maybe raising such errors will help
> to find fontification bugs sooner?

My feeling is that it's better to let the errors happen, so that we can
debug them.  But on the other hand, it's not me that gets inconvenienced
by such an error (I don't use gnus).

-- 
Alan Mackenzie (Nuremberg, Germany).




Notification sent to Juri Linkov <juri@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Alan Mackenzie <acm@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 7 Jul 2019 22:02:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 07 18:02:00 2019
Received: from localhost ([127.0.0.1]:57509 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkFEO-0000zT-Bg
	for submit <at> debbugs.gnu.org; Sun, 07 Jul 2019 18:02:00 -0400
Received: from brown.elm.relay.mailchannels.net ([23.83.212.23]:4349)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1hkFEM-0000zK-3M
 for 36492 <at> debbugs.gnu.org; Sun, 07 Jul 2019 18:01:59 -0400
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 89DCF1A1485;
 Sun,  7 Jul 2019 22:01:56 +0000 (UTC)
Received: from pdx1-sub0-mail-a86.g.dreamhost.com
 (100-96-14-11.trex.outbound.svc.cluster.local [100.96.14.11])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 0F98C1A1F7D;
 Sun,  7 Jul 2019 22:01:56 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a86.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.3); Sun, 07 Jul 2019 22:01:56 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Zesty-Illustrious: 266acaa96da7767a_1562536916329_2499528085
X-MC-Loop-Signature: 1562536916329:3574246849
X-MC-Ingress-Time: 1562536916328
Received: from pdx1-sub0-mail-a86.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a86.g.dreamhost.com (Postfix) with ESMTP id 48FA08016A;
 Sun,  7 Jul 2019 15:01:54 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=jv3+Zk5q4Fl0W2ZNhiu8whhmkj0=; b=
 P+BolK3TrwB214TCuV2vJEoJSSwJCDSltxqqgcgjLIhG2kmxqshmTL/zh0vWqOpF
 MOqaDpEhn0XT4UP3n2slW5Cp4EhuR5HNj1/T6Kr7YoaCrQD2QVCUTyezMw2MCAvd
 qoSo4A/5GenuSdT2dBFoIgY3pYwCGeoQXLcYo5mGoqo=
Received: from mail.jurta.org (m91-129-109-127.cust.tele2.ee [91.129.109.127])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a86.g.dreamhost.com (Postfix) with ESMTPSA id 16BBF8016F;
 Sun,  7 Jul 2019 15:01:51 -0700 (PDT)
X-DH-BACKEND: pdx1-sub0-mail-a86
From: Juri Linkov <juri@HIDDEN>
To: Alan Mackenzie <acm@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
Organization: LINKOV.NET
References: <20190706142748.85417.qmail@HIDDEN>
Date: Mon, 08 Jul 2019 00:52:02 +0300
In-Reply-To: <20190706142748.85417.qmail@HIDDEN> (Alan Mackenzie's
 message of "6 Jul 2019 14:27:48 -0000")
Message-ID: <871rz15xp1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: 0
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgeduvddrfeelgddtvdcutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecunecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdelrdduvdejnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtledruddvjedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegrtghmsehmuhgtrdguvgenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36492
Cc: 36492 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>> Opening this message in Gnus fails with the following backtrace
>>> because c-mode fails to fontify the attachment.
>
>> Actually, with the attachment in this message the bug in c-mode
>> font-lock is much easier to reproduce.
>
> That is one ugly piece of erroneous C.  ;-)
>
> What triggers the bug is the ) without a preceding (.  A variable
> recording the position of the opening ( is still set to nil, and we
> tried to use it in the given buffer with the unbalanced ).
>
>> [-- text/x-csrc, encoding 7bit, charset: US-ASCII, 3 lines, name: test.c --]
>
> The following patch fixes it, I hope.  Would you please do the usual,
> and confirm that it does indeed fix the bug (or tell me what's still
> wrong).

Thanks, Alan.  Now there is no error anymore.

I wonder if ignore-errors around font-lock-ensure in mm-display-inline-fontify
is still necessary to ensure no more bugs in other modes disrupt Gnus
by erroneous code in attachments?  Or maybe raising such errors will help
to find fontification bugs sooner?




Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 6 Jul 2019 14:27:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 06 10:27:56 2019
Received: from localhost ([127.0.0.1]:55695 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hjlfQ-0000BV-8k
	for submit <at> debbugs.gnu.org; Sat, 06 Jul 2019 10:27:56 -0400
Received: from colin.muc.de ([193.149.48.1]:22858 helo=mail.muc.de)
 by debbugs.gnu.org with smtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1hjlfO-0000BM-SH
 for 36492 <at> debbugs.gnu.org; Sat, 06 Jul 2019 10:27:55 -0400
Received: (qmail 85418 invoked by uid 3782); 6 Jul 2019 14:27:48 -0000
Date: 6 Jul 2019 14:27:48 -0000
Message-ID: <20190706142748.85417.qmail@HIDDEN>
From: Alan Mackenzie <acm@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
Organization: muc.de e.V.
In-Reply-To: <mailman.154.1562272763.2688.bug-gnu-emacs@HIDDEN>
X-Newsgroups: gnu.emacs.bug
User-Agent: tin/2.4.2-20171224 ("Lochhead") (UNIX) (FreeBSD/11.2-RELEASE-p9
 (amd64))
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36492
Cc: 36492 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

In article <mailman.154.1562272763.2688.bug-gnu-emacs@HIDDEN> you wrote:
> [-- text/plain, encoding 7bit, charset: US-ASCII, 6 lines --]

>> Opening this message in Gnus fails with the following backtrace
>> because c-mode fails to fontify the attachment.

> Actually, with the attachment in this message the bug in c-mode
> font-lock is much easier to reproduce.

That is one ugly piece of erroneous C.  ;-)

What triggers the bug is the ) without a preceding (.  A variable
recording the position of the opening ( is still set to nil, and we
tried to use it in the given buffer with the unbalanced ).

> [-- text/x-csrc, encoding 7bit, charset: US-ASCII, 3 lines, name: test.c --]

The following patch fixes it, I hope.  Would you please do the usual,
and confirm that it does indeed fix the bug (or tell me what's still
wrong).

Thanks!


diff -r eb4ee9bb0682 cc-engine.el
--- a/cc-engine.el	Thu Jul 04 13:01:08 2019 +0000
+++ b/cc-engine.el	Sat Jul 06 14:16:43 2019 +0000
@@ -9480,6 +9480,7 @@
 			   (not got-prefix)
 			   (or (eq context 'top) make-top)
 			   (eq (char-after) ?\))
+			   after-paren-pos
 			   (or (memq at-type '(nil maybe))
 			       (not got-identifier)
 			       (save-excursion
@@ -9516,7 +9517,7 @@
 	    ;; (con|de)structors in C++ and `c-typeless-decl-kwds'
 	    ;; style declarations.  That isn't applicable in an
 	    ;; arglist context, though.
-	    (when (and (> paren-depth 0)
+	    (when (and (> paren-depth 0) ; ensures `after-paren-pos' is non-nil
 		       (not got-prefix-before-parens)
 		       (not (eq at-type t))
 		       (or backup-at-type


-- 
Alan Mackenzie (Nuremberg, Germany).





Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 4 Jul 2019 21:19:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 04 17:19:37 2019
Received: from localhost ([127.0.0.1]:52047 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hj98j-0003pb-9S
	for submit <at> debbugs.gnu.org; Thu, 04 Jul 2019 17:19:37 -0400
Received: from colin.muc.de ([193.149.48.1]:14060 helo=mail.muc.de)
 by debbugs.gnu.org with smtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1hj98g-0003pA-Em
 for 36492 <at> debbugs.gnu.org; Thu, 04 Jul 2019 17:19:35 -0400
Received: (qmail 6375 invoked by uid 3782); 4 Jul 2019 21:19:28 -0000
Date: 4 Jul 2019 21:19:28 -0000
Message-ID: <20190704211928.6374.qmail@HIDDEN>
From: Alan Mackenzie <acm@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#36492: c-mode fails with errors during fontification
Organization: muc.de e.V.
In-Reply-To: <mailman.154.1562272763.2688.bug-gnu-emacs@HIDDEN>
X-Newsgroups: gnu.emacs.bug
User-Agent: tin/2.4.2-20171224 ("Lochhead") (UNIX) (FreeBSD/11.2-RELEASE-p9
 (amd64))
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36492
Cc: 36492 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello, Juri.

In article <mailman.154.1562272763.2688.bug-gnu-emacs@HIDDEN> you wrote:
> [-- text/plain, encoding 7bit, charset: US-ASCII, 6 lines --]

>> Opening this message in Gnus fails with the following backtrace
>> because c-mode fails to fontify the attachment.

> Actually, with the attachment in this message the bug in c-mode
> font-lock is much easier to reproduce.

Yes, I can reproduce the bug in that buffer with
(font-lock-fontify-region (point-min) (point-max).  I suspect it will be
fairly easy to diagnose and fix.

> [-- text/x-csrc, encoding 7bit, charset: US-ASCII, 3 lines, name: test.c --]

-- 
Alan Mackezie (Nuremberg, Germany).





Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at 36492 <at> debbugs.gnu.org:


Received: (at 36492) by debbugs.gnu.org; 4 Jul 2019 20:38:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 04 16:38:22 2019
Received: from localhost ([127.0.0.1]:51988 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hj8Un-0000Sg-O8
	for submit <at> debbugs.gnu.org; Thu, 04 Jul 2019 16:38:21 -0400
Received: from dog.birch.relay.mailchannels.net ([23.83.209.48]:63044)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1hj8Uk-0000SU-4Y
 for 36492 <at> debbugs.gnu.org; Thu, 04 Jul 2019 16:38:20 -0400
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 36DFA501316
 for <36492 <at> debbugs.gnu.org>; Thu,  4 Jul 2019 20:38:16 +0000 (UTC)
Received: from pdx1-sub0-mail-a17.g.dreamhost.com
 (100-96-4-176.trex.outbound.svc.cluster.local [100.96.4.176])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id BB2775019BD
 for <36492 <at> debbugs.gnu.org>; Thu,  4 Jul 2019 20:38:15 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a17.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.3); Thu, 04 Jul 2019 20:38:16 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Irritate-Eight: 39e124b3020f9be9_1562272696028_4213077041
X-MC-Loop-Signature: 1562272696028:467438982
X-MC-Ingress-Time: 1562272696028
Received: from pdx1-sub0-mail-a17.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a17.g.dreamhost.com (Postfix) with ESMTP id 8F1527F6BC
 for <36492 <at> debbugs.gnu.org>; Thu,  4 Jul 2019 13:38:14 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=MQDVg/Vu89xgjIC0ZfWAyb9bCIA=; b=
 XiRI+1T0CoyZuZDiEPaZiJukSZsSYOgolxwcG1g3lJTAI7wHfYOVBG+W3ca1etno
 Rv7DjW9gG16bTuW8cfKiz/8cBYzefNNzq7nt2eptIpAhF+zZpUOfFKEyWkUhDjlP
 qB4d/PyCINziCxTntErbPFwxpbdtGCJksvSs8fqbG64=
Received: from mail.jurta.org (m91-129-109-127.cust.tele2.ee [91.129.109.127])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a17.g.dreamhost.com (Postfix) with ESMTPSA id C81927F6CA
 for <36492 <at> debbugs.gnu.org>; Thu,  4 Jul 2019 13:38:13 -0700 (PDT)
X-DH-BACKEND: pdx1-sub0-mail-a17
From: Juri Linkov <juri@HIDDEN>
To: 36492 <at> debbugs.gnu.org
Subject: Re: bug#36492: c-mode fails with errors during fontification
Organization: LINKOV.NET
References: <87imsikh64.fsf@HIDDEN>
Date: Thu, 04 Jul 2019 23:08:25 +0300
In-Reply-To: <87imsikh64.fsf@HIDDEN> (Juri Linkov's message of "Wed, 
 03 Jul 2019 23:56:19 +0300")
Message-ID: <875zohad0m.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: 0
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgeduvddrfedvgdduheegucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucenucfjughrpefhvffuohhfffgjkfgfgggtsehmtderredtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtledruddvjeenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdelrdduvdejpdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepfeeigeelvdesuggvsggsuhhgshdrghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36492
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

> Opening this message in Gnus fails with the following backtrace
> because c-mode fails to fontify the attachment.

Actually, with the attachment in this message the bug in c-mode
font-lock is much easier to reproduce.

--=-=-=
Content-Type: text/x-csrc
Content-Disposition: inline; filename=test.c

int i)
{

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:
bug#36492; Package emacs,cc-mode. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 3 Jul 2019 20:57:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jul 03 16:57:15 2019
Received: from localhost ([127.0.0.1]:50142 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1himJW-0001oH-U6
	for submit <at> debbugs.gnu.org; Wed, 03 Jul 2019 16:57:15 -0400
Received: from lists.gnu.org ([209.51.188.17]:46056)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1himJV-0001o9-87
 for submit <at> debbugs.gnu.org; Wed, 03 Jul 2019 16:57:14 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:35946)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <juri@HIDDEN>) id 1himJT-0001C0-Pi
 for bug-gnu-emacs@HIDDEN; Wed, 03 Jul 2019 16:57:13 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RCVD_IN_DNSWL_NONE,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <juri@HIDDEN>) id 1himJR-0005fR-QL
 for bug-gnu-emacs@HIDDEN; Wed, 03 Jul 2019 16:57:11 -0400
Received: from antelope.elm.relay.mailchannels.net ([23.83.212.4]:2906)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <juri@HIDDEN>) id 1himJP-0005cP-Kd
 for bug-gnu-emacs@HIDDEN; Wed, 03 Jul 2019 16:57:08 -0400
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 8D51034195D
 for <bug-gnu-emacs@HIDDEN>; Wed,  3 Jul 2019 20:57:03 +0000 (UTC)
Received: from pdx1-sub0-mail-a34.g.dreamhost.com
 (100-96-8-155.trex.outbound.svc.cluster.local [100.96.8.155])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 156343415B5
 for <bug-gnu-emacs@HIDDEN>; Wed,  3 Jul 2019 20:57:03 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a34.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.3); Wed, 03 Jul 2019 20:57:03 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Imminent-Daffy: 7f8ac250685bcaef_1562187423374_22397168
X-MC-Loop-Signature: 1562187423373:1206309981
X-MC-Ingress-Time: 1562187423373
Received: from pdx1-sub0-mail-a34.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a34.g.dreamhost.com (Postfix) with ESMTP id DB4D780550
 for <bug-gnu-emacs@HIDDEN>; Wed,  3 Jul 2019 13:56:59 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to
 :subject:date:message-id:mime-version:content-type; s=
 linkov.net; bh=Il1tOqnvIp79dGzJwa+Z0iH125o=; b=WDOBrI0mDFlcrkS7z
 OdmkO4jF8Je8T5CwSGdDgQavOZZzLmM2V2Ei4WVlrTlnB9uyATw2TXWBDjXgbC3T
 4bQZCidA0g+KFJaXTcF1s4NlWt8a8qNzufzIoPZgxp7Zt653cOYMvJbL85jTLvP1
 rrT1t2Z+M3QuDGnVeCB889TDDU=
Received: from mail.jurta.org (m91-129-100-10.cust.tele2.ee [91.129.100.10])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a34.g.dreamhost.com (Postfix) with ESMTPSA id C03BE80561
 for <bug-gnu-emacs@HIDDEN>; Wed,  3 Jul 2019 13:56:58 -0700 (PDT)
X-DH-BACKEND: pdx1-sub0-mail-a34
From: Juri Linkov <juri@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: c-mode fails with errors during fontification
Organization: LINKOV.NET
Date: Wed, 03 Jul 2019 23:56:19 +0300
Message-ID: <87imsikh64.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: 0
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgeduvddrfedtgdduheejucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucenucfjughrpefhvffuohffkfgfgggtsehmtderredtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddttddruddtnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddttddruddtpdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepsghughdqghhnuhdqvghmrggtshesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 23.83.212.4
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain

Opening this message in Gnus fails with the following backtrace
after setting (setq diff-font-lock-syntax 'hunk-also)
because c-mode fails to fontify the attachment.

Debugger entered--Lisp error: (wrong-type-argument integer-or-marker-p nil)
  c-forward-decl-or-cast-1(0 top nil)
  (setq decl-or-cast (c-forward-decl-or-cast-1 match-pos context last-cast-end))
  (if (eq context 'not-decl) ...)
  (if (or (and (eq (get-text-property (point) 'face) 'font-lock-keyword-face) ...) ...) t ...)
  (if (if (or (and (eq (get-text-property (point) 'face) 'font-lock-keyword-face) ...) ...) t ...) ...)
  (lambda (match-pos inside-macro &optional toplev) ...)(0 nil t)
  c-find-decl-spots(11 "[[:alpha:]_]" (nil font-lock-type-face font-lock-constant-face font-lock-keyword-face) ...)
  (let (start-pos context ...) ... nil)
  (save-restriction (let (start-pos context ...) ... nil))
  (progn (save-restriction (let (start-pos context ...) ... nil)))
  (if (< (point) limit) (progn (save-restriction (let (start-pos context ...) ... nil))))
  c-font-lock-declarations(11)
  font-lock-fontify-keywords-region(1 11 nil)
  font-lock-default-fontify-region(1 11 nil)
  funcall(font-lock-default-fontify-region 1 11 nil)
  (let (new-beg new-end new-region case-fold-search) ...)
  c-font-lock-fontify-region(1 11 nil)
  font-lock-fontify-region(1 11)
  #f(compiled-function (beg end) #<bytecode 0x1fd6e1a05171>)(1 11)
  font-lock-ensure(1 11)
  diff-syntax-fontify-props(#("a/test.c" 0 8 (face (diff-file-header diff-header))) "int i)\n{\n1" (1 3) t)
  diff-syntax-fontify-hunk(78 111 t)
  diff-syntax-fontify(78 111)
  #f(compiled-function (beg end) #<bytecode 0x158f39208a39>)(78 111)
  diff--iterate-hunks(113 #f(compiled-function (beg end) #<bytecode 0x158f39208a39>))
  diff--font-lock-syntax(113)
  font-lock-fontify-keywords-region(1 113 nil)
  font-lock-default-fontify-region(1 113 nil)
  font-lock-fontify-region(1 113)
  #f(compiled-function (beg end) #<bytecode 0x1fd6e1a05171>)(1 113)
  font-lock-ensure()
  (if (eq major-mode 'fundamental-mode) nil (font-lock-ensure))
  (progn (if mode (let ((#:wconfig (current-window-configuration))) ...) ...) ...)
  (condition-case #:err (progn ...) ((debug error) (message "Error: %S" #:err) nil))
  (let ((font-lock-verbose nil) (enable-local-variables nil)) ...)
  (progn (buffer-disable-undo) (mm-enable-multibyte) ...)
  (unwind-protect (progn (buffer-disable-undo) (mm-enable-multibyte) ...) ...)
  (save-current-buffer (set-buffer #:temp-buffer) (unwind-protect ...))
  (let ((#:temp-buffer (generate-new-buffer " *temp*"))) (save-current-buffer ...))
  (let ((charset (mail-content-type-get (nth 1 handle) 'charset)) text coding-system ovs) ...)
  mm-display-inline-fontify(... diff-mode)
  mm-display-patch-inline(...)
  mm-display-inline(...)
  gnus-mime-display-single(...)
  gnus-mime-display-part(...)
  mapcar(gnus-mime-display-part (...))
  gnus-mime-display-mixed((...))
  gnus-mime-display-part((#("multipart/mixed" 0 15 ...) ...))
  gnus-display-mime()
  gnus-article-prepare-display()
  gnus-article-prepare(5460 nil)
  funcall(gnus-article-prepare 5460 nil)
  (prog1 (funcall (or gnus-summary-display-article-function ...) article all-header) ...)
  (if (null article) nil (prog1 (funcall (or gnus-summary-display-article-function ...) article all-header)))
  gnus-summary-display-article(5460 nil)
  (progn (gnus-summary-display-article article all-headers) ...)
  (if (or (and gnus-single-article-buffer ...)) ... 'old)
  (save-current-buffer (set-buffer gnus-summary-buffer) ...)
  (let ((article (or article (gnus-summary-article-number))) ...) ...)
  gnus-summary-select-article(nil nil pseudo)
  (eq (gnus-summary-select-article nil nil 'pseudo) 'old)
  (if (eq (gnus-summary-select-article nil nil 'pseudo) 'old) ...)
  gnus-summary-scroll-up(1)
  funcall-interactively(gnus-summary-scroll-up 1)
  call-interactively(gnus-summary-scroll-up nil nil)
  command-execute(gnus-summary-scroll-up)

I don't know if it's possible to fix c-mode to not raise the error
during fontification.  But at least the patch below will avoid this error
while displaying such attachments in Gnus.  Normally calling font-lock-ensure
ignores the fontification errors when called from font-lock.
But in mm-display-inline-fontify font-lock-ensure is called directly
from top-level, so this patch ignores its errors.

diff --git a/lisp/gnus/mm-view.el b/lisp/gnus/mm-view.el
index 6ffa1fc168..ebaf8435c0 100644
--- a/lisp/gnus/mm-view.el
+++ b/lisp/gnus/mm-view.el
@@ -500,7 +500,7 @@ mm-display-inline-fontify
 	      (setq mode major-mode)))
 	  ;; Do not fontify if the guess mode is fundamental.
 	  (unless (eq major-mode 'fundamental-mode)
-	    (font-lock-ensure))))
+	    (ignore-errors (font-lock-ensure)))))
       (setq text (buffer-string))
       (when (eq mode 'diff-mode)
 	(setq ovs (mapcar (lambda (ov) (list ov (overlay-start ov)

Then visiting such attachments will just leave this line in *Messages*
without wreaking much havoc:

  Error during redisplay: (jit-lock-function 1) signaled (wrong-type-argument integer-or-marker-p nil)


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=test.diff

diff --git a/test.c b/test.c
index aaa..bbb 100644
--- a/test.c
+++ b/test.c
@@ -1,3 +2,3 @@
 int i)
 {
-1
+2



--=-=-=--




Acknowledgement sent to Juri Linkov <juri@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#36492; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 9 Jul 2019 20:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.